
#import "GCLoginItemController.h"

@implementation GCLoginItemController

+(void) addAppAsLoginItemWithAllUsers:(BOOL)boolValue{
	//When using, do [GCLoginItemController addAppAsLoginItemWithAllUsers:YES] to have this app added as a Login Item for all users.
    //Do [GCLoginItemController addAppAsLoginItemWithAllUsers:NO] to have this app added just for the current user.
    
    //Retrieves path for application
	NSString * appPath = [[NSBundle mainBundle] bundlePath];
	CFURLRef url = (__bridge CFURLRef)[NSURL fileURLWithPath:appPath];

    LSSharedFileListRef loginItems;
    
	// Create a reference to the shared file list.
    if (boolValue == YES) {
        loginItems = LSSharedFileListCreate(NULL, kLSSharedFileListGlobalLoginItems, NULL);
    }
    else {
        loginItems = LSSharedFileListCreate(NULL, kLSSharedFileListSessionLoginItems, NULL);
    }
    
	if (loginItems) {
		//Insert an item to the list.
		LSSharedFileListItemRef item = LSSharedFileListInsertItemURL(loginItems, kLSSharedFileListItemLast, NULL, NULL, url, NULL, NULL);
		if (item) {
			CFRelease(item);
        }
	}
    
	CFRelease(loginItems);
}

+(void) removeAppFromLoginItemWithAllUsers:(BOOL)boolValue{
	//When using, do [GCLoginItemController removeAppFromLoginItemWithAllUsers:YES] to have this app removed as a Login Item for all users.
    //Do [GCLoginItemController removeAppFromLoginItemWithAllUsers:NO] to have this app removed just for the current user.
    
    //Retrieves path for application
	NSString * appPath = [[NSBundle mainBundle] bundlePath];
	CFURLRef url = (__bridge CFURLRef)[NSURL fileURLWithPath:appPath];
    
    LSSharedFileListRef loginItems;
    
    // Create a reference to the shared file list.
    if (boolValue == YES) {
        loginItems = LSSharedFileListCreate(NULL, kLSSharedFileListGlobalLoginItems, NULL);
    }
    else {
        loginItems = LSSharedFileListCreate(NULL, kLSSharedFileListSessionLoginItems, NULL);
    }
    
	if (loginItems) {
		UInt32 seedValue;
		//Retrieve the list of Login Items and cast them to
		// a NSArray so that it will be easier to iterate.
		NSArray  *loginItemsArray = (__bridge NSArray *)LSSharedFileListCopySnapshot(loginItems, &seedValue);
		for (int i = 0; i< [loginItemsArray count]; i++){
			LSSharedFileListItemRef itemRef = (__bridge LSSharedFileListItemRef)[loginItemsArray objectAtIndex:i];
			//Resolve the item with URL
			if (LSSharedFileListItemResolve(itemRef, 0, (CFURLRef*) &url, NULL) == noErr) {
				NSString * urlPath = [(__bridge NSURL*) url path];
                
				if ([urlPath isEqualToString:appPath])
					LSSharedFileListItemRemove(loginItems, itemRef);
			}
		}
	}
}

@end
